<?php
/*
Plugin Name: Likno Web Tabs WordPress Plugin
Plugin URI: http://www.likno.com/jquery-tabs/wordpress-tabs.html
Description: WordPress plugin for the Likno Web Tabs Builder - Create stylish, feature-rich tab controls for your blogs!
Version: 1.2
Author: Likno Software
Author URI: http://www.likno.com/ 
*/

/*

NOTE:

This plugin is licensed under the GNU General Public License (GPL).

As such, you may use the source code of this plugin as you wish.
This plugin is used as a bridge to a non-GPL licensed software (WebTabsBuilder PRO) that is a property of Likno Software.

The license of Likno Web TabsBuilder  states that a WordPress tabs can be used in **one single domain**.

Thus, the part of the code below that confirms that the tabs is used only in one domain **cannot** be changed/removed.

*/

global $lwtbPluginInstance;
$lwtbPluginInstance = new LWTB_Plugin();

class LWTB_Plugin{
    public $optionsMessage, $databaseMessage, $LWTB_ver , $lwtb_total_tabs, $wpdb, $dataArray,$lwtb_table_name,$lwtb_is_loaded,$lwtb_toload,$lwtb_excluded ;
	
	function LWTB_Plugin(){
		global $wpdb, $wp_version;
		$this->wpdb = $wpdb;

		$this->lwtb_toload = array();
		add_action( 'init', array($this,'LWTB_init_hook' ));
		add_action('init', array($this, 'LWTB_addbuttons'));
		//add_action('wp_head', array($this, 'LWTB_head_hook'));
		add_action('admin_menu', array($this, 'LWTB_add_option_pages'));
		add_action('wp_footer',array ($this,'LWTB_generate_linking_code'));
		add_shortcode( 'tabs', array($this, 'LWTB_shortcode') );
		add_action('wp_ajax_lwtb_tinymce', array($this, 'lwtb_tinymce'));
		add_action( 'admin_init', array($this,'LWTB_addmin_hook' ));
		if((float)$wp_version>=2.8){
			include_once ABSPATH . 'wp-content/plugins/webtabsbuilder-wordpress-plugin/widgetClass.php';
			add_action('widgets_init', create_function('', 'return register_widget("Widget_WebTabsBuilder");'));
		}

	}
	
	function LWTB_init_hook(){
		global $lwtb_table_name, $lwtb_total_tabs, $LWTB_ver;
		$this->lwtb_table_name = $lwtb_table_name = $this->wpdb->prefix . "lwtb";
		include_once ABSPATH . 'wp-content/plugins/webtabsbuilder-wordpress-plugin/include.php';
		wp_enqueue_script( 'jquery' );
		$LWTB_ver = $this->LWTB_ver = '1';


		$this->databaseMessage = lwtb_set_first_time_options();
		if (!empty($this->databaseMessage))
			$this->databaseMessage = "<div class=\"updated fade\" style=\"margin-top: 20px;\"><strong>".$this->databaseMessage."</strong></div>";
		$this->lwtb_total_tabs = $lwtb_total_tabs = $this->wpdb->get_var($this->wpdb->prepare("SELECT COUNT(*) FROM $this->lwtb_table_name;", null));
	}
	
	/*
	function LWTB_head_hook(){
		global $lwtb_table_name, $lwtb_total_tabs, $LWTB_ver;
		  $load_it = true;
			 $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwtb_table_name WHERE active = 1 order by id" );
	}
	*/
	/* 
	 * Add options page
	 */
	function LWTB_add_option_pages() {
		if (function_exists('add_options_page')) {
			$page = add_options_page('Likno Web Tabs WordPress Plugin', 'Likno Web Tabs Plugin', 8, __FILE__, array($this,'LWTB_options_page'));
		}
		add_action( 'admin_print_styles-' . $page,  array($this,'LWTB_admin_styles' ));
	}
	
	function lwtb_wp_settings_link($lwtb_links) {
		$lwtb_settings_link = '<a href="options-general.php?page=webtabsbuilder-wordpress-plugin/webtabsbuilder-wordpress.php">Settings</a>';
		array_unshift($lwtb_links, $lwtb_settings_link);
		return $lwtb_links;
	}
	
	/*
	 * Initialization of the admin panel.
	 */
	function LWTB_addmin_hook(){
		if (!session_id()){
			session_start();
		}
		$lwtb_plugin = plugin_basename(__FILE__);
		
		add_filter("plugin_action_links_$lwtb_plugin", array($this, 'lwtb_wp_settings_link' ));
		/* Register our stylesheet. */
		wp_register_script( 'LWTBScript', plugins_url('/script.js', __FILE__) );
		wp_register_script( 'ZeroClipboard', plugins_url('/ZeroClipboard.js', __FILE__) );
		wp_register_style( 'LWTBStylesheet', plugins_url('/stylesheet.css',__FILE__ ));
	}
	
	/*
	 * Add admin panel styles AND scripts
	 */
	function LWTB_admin_styles() {
		/*
		* It will be called only on your plugin admin page, enqueue our stylesheet here
		*/
		wp_enqueue_style( 'LWTBStylesheet' );
		wp_enqueue_script( 'LWTBScript' );
		wp_enqueue_script( 'ZeroClipboard' );
	}
	/* 
	 * Generate options page
	 */
	function LWTB_options_page() {
?>
<script type="text/javascript">
	ZeroClipboard.setMoviePath( '<?php echo plugins_url('/ZeroClipboard.swf', __FILE__)?>' );
</script>
        <div style="max-width: 980px; margin-left: 15px;">

	<span class="wrap">
	<h2>Likno Web Tabs Plugin v<?php echo $this->LWTB_ver; ?></h2>

<?php
		echo $this->databaseMessage;
		if (isset($_SESSION['message'])){
			echo $_SESSION['message'];
			unset ( $_SESSION['message'] );
		}
?>
		<p>For information and updates, please visit: 
		<a href="http://www.likno.com/jquery-tabs/wordpress-tabs.html">http://www.likno.com/jquery-tabs/wordpress-tabs.html</a></p>
<?php
		/* Display a message in the Options page if the tabs version is outdated
		NOTE: we do not check date as we have to recheck to display the message to the admin */
		
		if (get_option('LWTB_Check_show')) {
			$LWTB_buildText = LWTB_check();
			if ($LWTB_buildText != '') echo $LWTB_buildText;
			else update_option('LWTB_Check_show', FALSE);
		}
?>
	</span>
	<br />
        <br />

        <form method="post" enctype="multipart/form-data" id="theform1" name="theform1" action="<?php echo get_bloginfo('url')."/wp-content/plugins/webtabsbuilder-wordpress-plugin/actions.php"; ?>" >
        <div style="text-align: right;">
            <button class="button" type="button" onclick="theform1.theaction.value='createnew'; theform1.LWTB_selected_tab_c.value=theform.LWTB_selected_tab.value;theform1.submit();">Create New</button>
        <button <?php if ($this->lwtb_total_tabs == 1) echo "disabled='disabled'"; ?>class="button" type="button" onclick="theform1.theaction.value='delete';theform1.LWTB_tabs_id.value = eval('theform.LWTB_tabs_id_'+theform.LWTB_selected_tab.value + '.value'); theform1.LWTB_selected_tab_c.value=theform.LWTB_selected_tab.value;theform1.submit();">Delete</button>
        </div>
        <table id="uploader">
		<tr>
                    <td width="250">
                        <strong>Upload compiled ZIP file of your tab control: "<i id="upload_form_tabs_name"></i>"</strong></td>
		<td>
                    <input name="LWTB_files_zip" type="file" />
                    <input type="hidden" name="theaction" value="zip_update"/>
                    <input id="LWTB_selected_tab_c" name="LWTB_selected_tab_c" type="hidden" value="<?php echo get_option('LWTB_selected_tab');?>"/>
                    <input type="hidden" name="LWTB_tabs_id" value=""/>
                    <input type="button" name="zip_update" value="Upload ZIP file" onclick="theform1.LWTB_tabs_id.value = eval('theform.LWTB_tabs_id_'+theform.LWTB_selected_tab.value + '.value');theform1.LWTB_selected_tab_c.value=theform.LWTB_selected_tab.value;theform1.submit();"/>
                     <input type="hidden" name="abspath" value="<?php echo ABSPATH; ?>"/>
    <input type="hidden" name="ref" value="<?php echo admin_url("options-general.php?page=webtabsbuilder-wordpress-plugin/webtabsbuilder-wordpress.php"); ?>"/>
                </td>
                </tr>
                <tr>
                    <td width="250">&nbsp;</td>
		<td class="lwtb_itemInfo">
                    Select the ZIP file produced by the Likno Web Tabs Builder interface (containing the compiled tab control files). Then click the "Upload ZIP file" button and the tab control files will be added (or updated) online.<br />
		</td>
                </tr>
        </table>
        </form>
        <?php $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwtb_table_name" );?>

        <form method="post" enctype="multipart/form-data" id="theform" name="theform" action="<?php echo get_bloginfo('url')."/wp-content/plugins/webtabsbuilder-wordpress-plugin/actions.php"; ?>" >
            <input type="hidden" name="abspath" value="<?php echo ABSPATH; ?>"/>
            <input type="hidden" name="ref" value="<?php echo admin_url("options-general.php?page=webtabsbuilder-wordpress-plugin/webtabsbuilder-wordpress.php"); ?>"/>
            <input id="LWTB_selected_tab" name="LWTB_selected_tab" type="hidden" value="<?php echo get_option('LWTB_selected_tab');?>"/>
	<table>
		<tr>
                    <td width="250">
                        <strong>Online folder for tab controls files:</strong>
                    </td>
		<td>
                    <input id="LWTB_tabs_path" name="LWTB_tabs_path" onkeyup="lwtb_set_path();" onchange="lwtb_set_path();" type="text" size="30" value="<?php echo get_option('LWTB_tabs_path'); ?>"/>&nbsp;&nbsp;(relative to blog's root folder)
                </td>
                </tr>
		<tr>
                    <td width="250">&nbsp;</td>
		<td class="lwtb_itemInfo">
			Every time you compile your Likno Web Tabs Builder project you should also upload the produced ZIP file online (see above). Its content (tab control files) are then automatically added by the plugin to this folder.
                                                <br><?php echo get_bloginfo('url');?><span id="LWTB_the_path"><?php echo get_option('LWTB_tabs_path');?></span>
                                                <br>(note: you might need to create this online folder yourself)
		</td>
                </tr>
	</table>
	
	<div class="submit" style="text-align: right;">
		<input type="button" name="info_update" value="Save settings &raquo;" onclick="theform.theaction.value='info_update'; lwtb_form_validate();"/>
	
	</div>
	<div id="LWTB_tab_wrapper">
		<div id="LWTB_tabHeaders">
<?php 
		for ($lwtb=0; $lwtb<$this->lwtb_total_tabs; $lwtb++) {
			echo "<div class='lwtb_tab_header' style='color: #".($myrows[$lwtb]->active ?"0099":"9900")."00;' id='LWTB_tab_header_$lwtb' onclick='lwtb_show_tab($lwtb)'>". $myrows[$lwtb]->name ."</div>";
		}
?>
		</div>
		<div id="LWTB_tabBodies">
<?php 
		for ($lwtb=0; $lwtb<$this->lwtb_total_tabs; $lwtb++) {
?>
                    <div class='lwtb_tab_body' id='LWTB_tab_body_<?php echo $lwtb;?>'>
				<div>
                                    <input type="hidden" name="LWTB_tabs_id_<?php echo $lwtb;?>" value="<?php echo $myrows[$lwtb]->id?>"/>
                                    <input id="LWTB_tabs_active_<?php echo $lwtb;?>" name="LWTB_tabs_active_<?php echo $lwtb;?>" onclick="lwtb_uncheck(<?php echo $lwtb;?>);" type="checkbox" value="true" <?php if( $myrows[$lwtb]->active) echo "checked='checked'"; ?> /> <strong>Show "<span id="lwtb_active_name_<?php echo $lwtb?>"><?php echo $myrows[$lwtb]->name;?></span>" in blog</strong>
				&nbsp;&nbsp;&nbsp;<?php if (!$myrows[$lwtb]->active) { ?><span id='LWTB_unchecked_<?php echo $lwtb;?>' style='color:#990000;'>Unchecked! (this tabs will not appear in your blog)</span><?php } else { ?><span id='LWTB_unchecked_<?php echo $lwtb;?>' style='color:#009900;'>(this tab control will appear in your blog)</span><?php } ?>
                                </div>
				<div style="padding-left: 19px; margin-top: 13px;"><strong>tab control name: </strong> <input maxlength="256" onkeyup="lwtb_name_change(<?php echo $lwtb;?>, this.value);" onchange="lwtb_name_change(<?php echo $lwtb;?>, this.value);" id="LWTB_tabs_name_<?php echo $lwtb;?>"name="LWTB_tabs_name_<?php echo $lwtb;?>" type="text" size="30" value="<?php echo $myrows[$lwtb]->name ?>" original="<?php echo $myrows[$lwtb]->name ?>"/><span class="lwtb_name_notice" id="lwtb_name_notice_<?php echo $lwtb;?>"></span></div>
				<div style="padding-left: 19px;" class="lwtb_itemInfo">Please make sure that the "tab control name" value matches the value in the "Compiled Javascript Project" property of your Likno Web Tabs Builder project file (<i>Tools > Project Properties > Compile Properties</i>). <a href="javascript:void(0)" onclick="lwtb_folder_info('',<?php echo $lwtb;?>);">show me</a></div>
				<div id="LWTB_folder_info_<?php echo $lwtb;?>" style="margin-top: 20px; display: none; background-color: #FEFCF5; border: #E6DB55 solid 1px;">
					<table>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 10px; padding-bottom: 10px;">
                                                        <strong>More info</strong> - <a href="javascript:void(0)" onclick="lwtb_folder_info('none',<?php echo $lwtb;?>);">close</a>
                                                    </td>
                                                </tr>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 0px; padding-bottom: 10px;">
							<img src="<?php echo get_bloginfo('url');?>/wp-content/plugins/webtabsbuilder-wordpress-plugin/tabsname.jpg" alt="Project Name" title="Project Name"/>
                                                        <br />
                                                        Compiled Javascript Project (see <span style="color: red;">1</span>) and tabs name (see <span style="color: red;">2</span>) must be the same
                                                        <br />
                                                        <img src="<?php echo get_bloginfo('url');?>/wp-content/plugins/webtabsbuilder-wordpress-plugin/tabsnamesec.jpg" alt="Tabs Name" title="Tabs Name"/>
                                                    </td>
                                                </tr>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 0px; padding-bottom: 10px;">
							<a href="javascript:void(0)" onclick="lwtb_folder_info('none',<?php echo $lwtb;?>);">close</a>
                                                            </td>
                                                </tr>
                                        </table>
				</div>
                                <br />
                                <div>
                                    <fieldset id="lwtb_type_fieldset_<?php echo $lwtb;?>">
                                    <input onclick="lwtb_print_div(this.checked,<?php echo $lwtb?>);" type="checkbox" name="lwtb_type_<?php echo $lwtb?>" value="embedded" <?php checked( $myrows[$lwtb]->print_div, 1 ) ?> /> <strong>Print 'DIV' element</strong><br />
                                    <div id="lwtb_embeddedDetails_<?php echo $lwtb?>" <?php if ( $myrows[$lwtb]->print_div ==  0 ) :?> style="display: none" <?php endif;?>>A 'DIV' element will be produced with this id: <input readonly type="text" id="lwtb_divname<?php echo $lwtb?>" value="lwtbAnchor-<?php echo $myrows[$lwtb]->name?>" style="width: 200px;"/>
                                        <button class="button" type="button" id="lwtb_copy_button_<?php echo $lwtb?>">Copy</button>
                                       </div>
                                </fieldset>
                                </div>
                                <br />
                                <div class="LWTB_section">Tab Control Positioning Method</div>
                                <div style="padding: 20px 0;">Please select a tab control position where you want your tab control to appear:
				<select style="margin-left: 20px;" onchange="lwtb_tabs_position(this.value , <?php echo $lwtb;?>)" name="lwtb_tabs_position_<?php echo $lwtb;?>" id="lwtb_tabs_position_<?php echo $lwtb;?>">
                                            <option value="shortcode" <?php selected( isset( $myrows[$lwtb]->position ) && $myrows[$lwtb]->position == "shortcode" ); ?>>shortcode</option>
                                            <option value="template_tag" <?php selected( isset( $myrows[$lwtb]->position ) && $myrows[$lwtb]->position == "template_tag" ); ?>>template tag</option>
                                            <?php global $wp_registered_sidebars;
                                            global $wp_version;
                                            if ((float)$wp_version>=2.2 &&  count($wp_registered_sidebars > 1)):?>
                                            <option value="lwtb_widget" <?php selected( isset( $myrows[$lwtb]->position ) && $myrows[$lwtb]->position == "lwtb_widget" ); ?>>widget</option>
                                            <?php endif;?>
                                        </select>
                                     <div class="lwtb_tabs_position" id="lwtb_shortcode_position_<?php echo $lwtb;?>" <?php if ($myrows[$lwtb]->position != 'shortcode') echo 'style="display: none;"';?>>You have selected the <em>’shortcode’</em> positioning method. This means that you can add this tab control inside the post or page that you want, using the visual editor.</div>
                                    <div class="lwtb_tabs_position" id="lwtb_template_tag_position_<?php echo $lwtb;?>" <?php if ($myrows[$lwtb]->position !="template_tag") echo 'style="display: none;"';?>>
                                    Copy and paste this code in the template file where you want the tab control to appear.
                                    <br />
                                        <textarea id="template_tag_code_<?php echo $lwtb?>" cols="45" rows="5">
&lt;?php if (function_exists('lwtb_template_tag'))
    lwtb_template_tag('<?php echo $myrows[$lwtb]->name?>');?&gt;

                                    </textarea>
                                            <button class="button" type="button" id="lwtb_template_tag_button_<?php echo $lwtb?>">Copy</button>


                                    </div>
                                    <div class="lwtb_tabs_position" id="lwtb_widget_position_<?php echo $lwtb;?>" <?php if ($myrows[$lwtb]->position != "lwtb_widget") echo 'style="display: none;"';?>>
                                     You have selected the <em>'Widget'</em> positioning method.
                                        A widget instance for this tab control is initially created and found in the <a href="<?php echo admin_url('widgets.php');?>#wp_inactive_widgets">widgets administration page</a>, under the "Inactive Widgets" section. Just drag this widget instance and drop it inside the Widget Area that you want.</div>

                        </div>
                                </div>
<?php
		}	// end of tab body for loop
?>
		</div>	<!-- tab_bodies -->
	</div>	<!-- tab_wrapper -->
	<br>
	<br>
	<div style="text-align: center;" class="lwtb_itemInfo"><span style="color:#990000;">Note:</span> Always click the "Save settings" button below to apply your changes. If you leave this page without saving you will lose your unsaved changes.</div>
	<div class="submit" style="text-align: center;">
		<input type="button" name="info_update" value="Save settings &raquo;" onclick="theform.theaction.value='info_update'; lwtb_form_validate();;"/>
	</div>
	
	<input type="hidden" name="theaction" value="" />
	<script type="text/javascript">
            LWTB_TOTAL_TABS_JS = <?php echo $this->lwtb_total_tabs?>;
            lwtb_show_tab(<?php echo get_option('LWTB_selected_tab'); ?>);
        </script>
	
</form>
</div>	
<?php
	}	// END of LWTB_options_page()
	
	function LWTB_generate_linking_code() {
		$myrows = $this->wpdb->get_results("SELECT * FROM $this->lwtb_table_name WHERE name in (".implode(",", $this->lwtb_toload).") order by id");
		$i=0;
		for ($i=0; $i<count($myrows); $i++) {
			$lwtb_name = $myrows[$i]->name;
			$output= "<!-- ******** BEGIN LIKNO WEB TABS CODE FOR ".$lwtb_name." ******** -->\n";
			$output .= "<script type=\"text/javascript\">var lwtbLinkedBy=\"LiknoWebTabs [1]\",lwtbName=\"".$lwtb_name."\",lwtbBN=\"WP\";</script>\n
			<script charset=\"UTF-8\" src=\"".get_bloginfo('url') . get_option('LWTB_tabs_path').str_replace('-','_',$lwtb_name)."/".$lwtb_name.".js\" type=\"text/javascript\"></script>\n
			<!-- ******** END LIKNO WEB TABS CODE FOR ".$lwtb_name." ******** -->";
			echo $output;
		}
	}
	/* 
	 * Initialize query var for sitemap permalinks
	 */
	function LWTB_query_vars ( $lwtb_vars ) {
		$lwtb_vars[] = "pg";
		return $lwtb_vars;
	}

	//add_filter('query_vars', 'LWTB_query_vars');
	function LWTB_shortcode( $atts ) {
		extract( shortcode_atts( array(
			'name' => 'tabs1',
			'everywhere' => false
		), $atts ) );
		if (!in_array($name, $this->lwtb_toload)){
			if (is_singular() || $everywhere){
				$name = $this->wpdb->get_var("SELECT name from $this->lwtb_table_name where name = '$name' && position = 'shortcode' and active = 1");
				if (!empty($name)){
					$this->lwtb_toload[] = "'".$name."'";
					if ($this->wpdb->get_var("SELECT print_div from $this->lwtb_table_name where name = '$name' ")== 1){
						return "<span style='display: block;' id='lwtbAnchor-$name'></span>";
					} else return "";
				}
				return "";
			} else return "";
		} else return "";
	}

	function LWTB_addbuttons() {
		// Don't bother doing this stuff if the current user lacks permissions
		if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
			return;

		// Add only in Rich Editor mode
		if ( get_user_option('rich_editing') == 'true') {
			add_filter("mce_external_plugins", array($this, "LWTB_add_tinymce_plugin"));
			add_filter('mce_buttons', array($this, 'LWTB_register_button'));
		}
	}

	function LWTB_register_button($buttons) {
		array_push($buttons, "|", "lwtb");
		return $buttons;
	}
	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	function LWTB_add_tinymce_plugin($plugin_array) {
		$plugin_array['lwtb'] = get_bloginfo('url').'/wp-content/plugins/webtabsbuilder-wordpress-plugin/editor_plugin.js';
		return $plugin_array;
	}
	// init process for button control
	function lwtb_tinymce() {
		if ( !current_user_can('edit_pages') && !current_user_can('edit_posts') )
			die(__("You are not allowed to be here"));
		require_once('LWTB_tinymce.php');
			die();
	}
//add_action('loop_start','lwtb_floated' );
}

function lwtb_template_tag($name){
    global $lwtbPluginInstance;
    if ($lwtbPluginInstance->wpdb->get_var("SELECT position from $lwtbPluginInstance->lwtb_table_name where name = '$name' and active = 1 ")=="template_tag"){
        $lwtbPluginInstance->lwtb_toload[]= "'".$name."'";
        if ($lwtbPluginInstance->wpdb->get_var("SELECT print_div from $lwtbPluginInstance->lwtb_table_name where name = '$name' ")== 1){
            echo "<div id='lwtbAnchor-".$name."'></div>";
        }
    }
}
?>